from math import floor
import numpy as np


# parameters ##############################

#fasta_dir = 'genomes\mm8\\'
# find ###################################
def find(aList, key):
    idx = []
    for i in range(len(aList)):
         if  key == aList[i]:
               idx.append(i)
    return idx

# findstr ##############################

def findstr(aStr,key):
      idx = []
      slen = len(key)
      for i in range(len(aStr)-slen+1):
            if key == aStr[i:i+slen]:
                  idx.append(i)
      return idx
# overcount ######################
def overcount(aStr,pattern):
    """Returns how many p on s, works for overlapping"""
    ocu=0
    x=0
    while 1:
      try:
        i=aStr.index(pattern,x)
      except ValueError:
        break
      ocu+=1
      x=i+1
    return ocu

# ReadGenome ###########################
def ReadGenome(fs, bpstart, bpend):

# Read genomic sequences downloaded in FASTA format
#Input:
# fs -- fasta file containing the query genomic sequences (fix chromosome)
# bpstart --- start bp coordinate
# bpend --- end bp coordinate
# Output:
#     extracted sequence.

       gf = file(fs)
       gf.seek(0,0)
       gf.readline()  #read the first line; the pointer is at the second line
       nbp = bpend - bpstart
       offset = bpstart + floor(bpstart/50) #assuming each line contains 50 characters; add 1 offset per line
       gf.seek(offset,1)
       seq_tmp = gf.read(nbp+int(floor(nbp/50))+1)
       seq_tmp = seq_tmp.replace('\n','')
       gf.close
       return seq_tmp[0:nbp]


# seq2code ###############################
def seq2code(seq):
    seq2 = seq.upper()
    y = np.zeros(len(seq),dtype=int)
    I = find(seq2,'A')
    y[I] = 1
    I = find(seq2,'C')
    y[I] = 2
    I=find(seq2,'G')
    y[I] = 3
    I = find(seq2,'T')
    y[I] = 4
    return y





